#include <stdio.h>
#include <stdlib.h>

typedef enum _piece { SAFE, VULN, QUEEN } piece;

void print(int n, int m, piece tab[n][m]);
void init_board(int n, int m, piece tab[n][m]);
void couverture(int n, int m, piece tab[n][m], int r_x, int r_y);

void main() {
    int n = 8;
    piece board[n][n];
    init(n, n, board, SAFE);

    print(n, n, board);
    printf("Entrez la colonne de la reine (1..%d): ", n);
    int r_j;
    scanf("%d", &r_j);
    r_j--;
    printf("Entrez la ligne de la reine ('a'..'%c'): ", n - 1 + 'a');
    char ch[1];
    scanf("%s", ch);
    couverture(n, n, board, ch[0] - 'a', r_j);
    print(n, n, board);
}

void print(int n, int m, piece board[n][m]) {
    for (int i = n - 1; i >= 0; i--) {
        printf("%c ", 'a' + i);
        for (int j = 0; j < m; j++) {
            switch (board[i][j]) {
                case VULN:
                    printf(" *");
                    break;
                case SAFE:
                    printf(" o");
                    break;
                case QUEEN:
                    printf(" R");
            }
        }
        printf("\n");
    }
    printf("\n  ");
    for (int j = 0; j < m; j++) {
        printf(" %d", j + 1);
    }
    printf("\n");
}

void couverture(int n, int m, piece board[n][m], int r_i, int r_j) {
    for (int k = 0; k < n; k++) {
        board[k][r_j] = VULN; // colonne de la reine
    }
    for (int k = 0; k < m; k++) {
        board[r_i][k] = VULN; // ligne de la reine
        int tmp       = r_j - k;
        if (0 <= r_i + tmp && r_i + tmp < n) { // diagonale montante
            board[r_i + tmp][k] = VULN;
        }
        if (0 <= r_i - tmp && r_i - tmp < n) { // diagonale descendante
            board[r_i - tmp][k] = VULN;
        }
    }
    board[r_i][r_j] = QUEEN;
}

void init(int n, int m, piece tab[n][m], piece pce) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            tab[i][j] = pce;
        }
    }
}

